unit Main;

                               interface
////////////////////////////////////////////////////////////////////////////////
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Buttons, Menus, ExtCtrls, Spin, ToolWin, ImgList, IniFiles;

type
  TfrmMain = class(TForm)
    sbrStatus: TStatusBar;
    tbrTollBar: TToolBar;
    cbxInterfaces: TComboBox;
    ToolButton1: TToolButton;
    tbnRefresh: TToolButton;
    ToolButton3: TToolButton;
    tbnInterfaceOpen: TToolButton;
    tbnInterfaceClose: TToolButton;
    ToolButton4: TToolButton;
    ToolButton6: TToolButton;
    tbnHelpAbout: TToolButton;
    ToolButton2: TToolButton;
    imgToolIcons: TImageList;
    pgcPages: TPageControl;
    tbsCommon: TTabSheet;
    grbCommon: TGroupBox;
    btnGetVersion: TBitBtn;
    dtpDate: TDateTimePicker;
    dtpTime: TDateTimePicker;
    btnGetDate: TBitBtn;
    btnGetTime: TBitBtn;
    btnSetDate: TBitBtn;
    btnSetTime: TBitBtn;
    grbChan_1: TGroupBox;
    Label1: TLabel;
    lblTagMemTime_1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    btnGetTagMemTime_1: TBitBtn;
    btnSetTagMemTime_1: TBitBtn;
    tbrTagMemTime_1: TTrackBar;
    trbDumping_1: TTrackBar;
    btnGetDumping_1: TBitBtn;
    btnSetDumping_1: TBitBtn;
    btnGetNumTags_1: TBitBtn;
    btnGetFirstTag_1: TBitBtn;
    btnGetNextTag_1: TBitBtn;
    edtNumTags_1: TEdit;
    edtFirstTag_1: TEdit;
    edtNextTag_1: TEdit;
    rgrChanActive_1: TRadioGroup;
    grbChan_2: TGroupBox;
    Label4: TLabel;
    lblTagMemTime_2: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    btnGetTagMemTime_2: TBitBtn;
    btnSetTagMemTime_2: TBitBtn;
    tbrTagMemTime_2: TTrackBar;
    trbDumping_2: TTrackBar;
    btnGetDumping_2: TBitBtn;
    btnSetDumping_2: TBitBtn;
    btnGetNumTags_2: TBitBtn;
    btnGetFirstTag_2: TBitBtn;
    btnGetNextTag_2: TBitBtn;
    edtNumTags_2: TEdit;
    edtFirstTag_2: TEdit;
    edtNextTag_2: TEdit;
    rgrChanActive_2: TRadioGroup;
    grbReaderAddr: TGroupBox;
    Label5: TLabel;
    Label8: TLabel;
    sedReaderAddr: TSpinEdit;
    sedSetNewAddress: TSpinEdit;
    btnChangeAddr: TBitBtn;
    tbsTransactions: TTabSheet;
    btnClearBuffer: TBitBtn;
    btnGetNumber: TBitBtn;
    edtNumTransact: TEdit;
    btnGetNext: TBitBtn;
    btnClearScreen: TBitBtn;
    lvwTransactions: TListView;
    procedure tbnHelpAboutClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure tbnRefreshClick(Sender: TObject);
    procedure tbnInterfaceOpenClick(Sender: TObject);
    procedure tbnInterfaceCloseClick(Sender: TObject);
    procedure btnGetVersionClick(Sender: TObject);
    procedure btnGetDateClick(Sender: TObject);
    procedure btnGetTimeClick(Sender: TObject);
    procedure btnSetDateClick(Sender: TObject);
    procedure btnSetTimeClick(Sender: TObject);
    procedure tbrTagMemTime_1Change(Sender: TObject);
    procedure btnGetTagMemTime_1Click(Sender: TObject);
    procedure btnSetTagMemTime_1Click(Sender: TObject);
    procedure btnGetDumping_1Click(Sender: TObject);
    procedure btnSetDumping_1Click(Sender: TObject);
    procedure btnGetNumTags_1Click(Sender: TObject);
    procedure btnGetFirstTag_1Click(Sender: TObject);
    procedure btnGetNextTag_1Click(Sender: TObject);
    procedure tbrTagMemTime_2Change(Sender: TObject);
    procedure btnGetTagMemTime_2Click(Sender: TObject);
    procedure btnSetTagMemTime_2Click(Sender: TObject);
    procedure btnGetDumping_2Click(Sender: TObject);
    procedure btnSetDumping_2Click(Sender: TObject);
    procedure btnGetNumTags_2Click(Sender: TObject);
    procedure btnGetFirstTag_2Click(Sender: TObject);
    procedure btnGetNextTag_2Click(Sender: TObject);
    procedure rgrChanActive_1Click(Sender: TObject);
    procedure rgrChanActive_2Click(Sender: TObject);
    procedure btnChangeAddrClick(Sender: TObject);
    procedure btnClearScreenClick(Sender: TObject);
    procedure btnClearBufferClick(Sender: TObject);
    procedure btnGetNumberClick(Sender: TObject);
    procedure btnGetNextClick(Sender: TObject);
  private
    { Private declarations }
    opres: short;
    TranNumber: integer;

    procedure EnableControls(AState: boolean);
    function ShowStatus(ACode: integer): integer;
    procedure FindPorts();
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

                              implementation
////////////////////////////////////////////////////////////////////////////////
uses
  R2x245,
  //DLL_Main,
  R2x245Types,
  ErrCodes,
  ErrMsg,
  Transact, About;
{$R *.DFM}
var
{
  TInterfDescriptor = packed record
    Number: short;
    Desc:   packed array[0..31] of char;
  end;
}
  IntDesc: TInterfDescriptor;

////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.FormCreate(Sender: TObject);
begin
  EnableControls(false);
  sbrStatus.Panels[0].Text := ' ';
  sbrStatus.Panels[3].Text := ': ' + ' - ';
  //
  pgcPages.ActivePage := tbsCommon;
  //     
  FindPorts;
end;

////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  InterfaceClose();
end;

////////////////////////////////////////////////////////////////////////////////
//    -     .   
//   2 ,   3 -   
//
////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.EnableControls(AState: boolean);
var
  I: integer;
  Temp: TComponent;
begin
  for I := 0 to ComponentCount - 1 do
  begin
    Temp := Components[I];

    // ToolButton
    if (Temp is TToolButton) and (Temp.Tag = 2) then
        (Temp as TToolButton).Enabled := AState;
    if (Temp is TToolButton) and  (Temp.Tag = 3) then
      (Temp as TToolButton).Enabled := NOT AState;

    // TBitBtn
    if (Temp is TBitBtn) and (Temp.Tag = 2) then
        (Temp as TBitBtn).Enabled := AState;
    if (Temp is TBitBtn) and  (Temp.Tag = 3) then
      (Temp as TBitBtn).Enabled := NOT AState;

    // TMenuItem
    if (Temp is TMenuItem) and (Temp.Tag = 2) then
      (Temp as TMenuItem).Enabled := AState;
    if (Temp is TMenuItem) and (Temp.Tag = 3) then
      (Temp as TMenuItem).Enabled := NOT AState;

    // TCheckBox
    if (Temp is TCheckBox) and (Temp.Tag = 2) then
      (Temp as TCheckBox).Enabled := AState;
    if (Temp is TCheckBox) and (Temp.Tag = 3) then
      (Temp as TCheckBox).Enabled := NOT AState;

    // TRadioGroup
    if (Temp is TRadioGroup) and (Temp.Tag = 2) then
      (Temp as TRadioGroup).Enabled := AState;
    if (Temp is TRadioGroup) and (Temp.Tag = 3) then
      (Temp as TRadioGroup).Enabled := NOT AState;

    // TSpinEdit
    if (Temp is TSpinEdit) and (Temp.Tag = 2) then
      (Temp as TSpinEdit).Enabled := AState;
    if (Temp is TSpinEdit) and (Temp.Tag = 3) then
      (Temp as TSpinEdit).Enabled := NOT AState;

    // TTabSheet
    if (Temp is TTabSheet) and (Temp.Tag = 2) then
      (Temp as TTabSheet).TabVisible := AState;
      
    // TComboBox
    if (Temp is TComboBox) and (Temp.Tag = 2) then
      (Temp as TComboBox).Enabled := AState;
    if (Temp is TComboBox) and (Temp.Tag = 3) then
      (Temp as TComboBox).Enabled := NOT AState;
  end;
  //
  if (AState) then begin
    tbsTransactions.TabVisible := true;
  end else begin
    pgcPages.ActivePage := tbsCommon;
    tbsTransactions.TabVisible := false;
  end;
end;

////////////////////////////////////////////////////////////////////////////////
function TfrmMain.ShowStatus(ACode: integer): integer;
begin
  sbrStatus.Panels[3].Text := ' = ' + IntToStr(ACode) + ' / ' +
    ErrMsgText(ACode);
  Result := ACode;
end;

////////////////////////////////////////////////////////////////////////////////
//                
////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.FindPorts();
var
  n: integer;
  s: string;
begin
  cbxInterfaces.Clear;
  Application.ProcessMessages;
  n := InterfaceEnumerate;
  if n > 0 then begin
    if InterfaceGetFirst(IntDesc) = R245_RES_OK then begin
      //  
      s := pchar(@IntDesc.Desc);
      cbxInterfaces.Items.Add(s);
      //  
      while (InterfaceGetNext(IntDesc) = R245_RES_OK) do begin
        s := pchar(@IntDesc.Desc);
        cbxInterfaces.Items.Add(s);
      end;
    end;
  end;
  //    
  if (cbxInterfaces.Items.Count > 0) then
    cbxInterfaces.ItemIndex := 0;
end;

////////////////////////////////////////////////////////////////////////////////
//                    
////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.tbnRefreshClick(Sender: TObject);
begin
  FindPorts;
end;

////////////////////////////////////////////////////////////////////////////////
//                      
////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.tbnInterfaceOpenClick(Sender: TObject);
begin
  if cbxInterfaces.Items.Count > 0 then begin
    if ShowStatus(InterfaceOpen(cbxInterfaces.ItemIndex)) = R245_RES_OK then begin
      EnableControls(true);
      sbrStatus.Panels[0].Text := ' No ' + IntToStr(cbxInterfaces.ItemIndex);
    end;
  end;
end;

////////////////////////////////////////////////////////////////////////////////
//                     
////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.tbnHelpAboutClick(Sender: TObject);
begin
  frmAbout.ShowModal;
end;

procedure TfrmMain.tbnInterfaceCloseClick(Sender: TObject);
begin
  pgcPages.ActivePage := tbsCommon;
  //
  InterfaceClose();
  sbrStatus.Panels[0].Text := ' ';
  EnableControls(false);
end;

// #############################################################################
//
//                          
//
// #############################################################################
const
  CHAR_BUF_LEN = 64;
var
  CharBuff: array[0..CHAR_BUF_LEN - 1] of char;
  //      
  DT: TDateTime;
  Year, Month, Day: word;
  Hour, Min, Sec, MSec: word;
  DOW: word;

////////////////////////////////////////////////////////////////////////////////
//                       
////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.btnGetVersionClick(Sender: TObject);
begin
  if ShowStatus(GetReaderVersion(sedReaderAddr.Value, @CharBuff, CHAR_BUF_LEN)) = R245_RES_OK then
  begin
    ShowMessage('Reader version = <<' + pchar(@CharBuff) + '>>');
  end;
end;

////////////////////////////////////////////////////////////////////////////////
//                    
////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.btnGetDateClick(Sender: TObject);
begin
  if ShowStatus(GetReaderDate(sedReaderAddr.Value, Year, Month, Day)) = R245_RES_OK then begin
    DT := EncodeDate(Year, Month, Day);
    dtpDate.Date := DT;
  end;
end;

////////////////////////////////////////////////////////////////////////////////
//                    
////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.btnGetTimeClick(Sender: TObject);
begin
  if ShowStatus(GetReaderTime(sedReaderAddr.Value, Hour, Min, Sec, DOW)) = R245_RES_OK then begin
    DT := EncodeTime(Hour, Min, Sec, 0);
    dtpTime.Time := DT;
  end;
end;

////////////////////////////////////////////////////////////////////////////////
//                   
////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.btnSetDateClick(Sender: TObject);
begin
  dtpDate.DateTime := Now;
  DecodeDate(Now, Year, Month, Day);
  ShowStatus(SetReaderDate(sedReaderAddr.Value, Year, Month, Day));
end;

////////////////////////////////////////////////////////////////////////////////
//                    
////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.btnSetTimeClick(Sender: TObject);
begin
  dtpTime.DateTime := Now;
  DecodeTime(Now, Hour, Min, Sec, Msec);
  DOW := DayOfWeek(Now);
  ShowStatus(SetReaderTime(sedReaderAddr.Value, Hour, Min, Sec, DOW));
end;

//##############################################################################
//                            1
//##############################################################################
procedure TfrmMain.tbrTagMemTime_1Change(Sender: TObject);
begin
  lblTagMemTime_1.Caption := FloatToStr(tbrTagMemTime_1.Position / 10);
end;

{ ------------------------------------------------------------------------------
     1
------------------------------------------------------------------------------ }
procedure TfrmMain.rgrChanActive_1Click(Sender: TObject);
begin
  if rgrChanActive_1.ItemIndex = 0 then
    //   
    ShowStatus(SetChannelActivity_1(sedReaderAddr.Value, 0))
  else
    //   
    ShowStatus(SetChannelActivity_1(sedReaderAddr.Value, 1))
end;

{ ------------------------------------------------------------------------------
        1
------------------------------------------------------------------------------ }
procedure TfrmMain.btnGetTagMemTime_1Click(Sender: TObject);
var
  t: short;
begin
  if ShowStatus(GetTagMemTime_1(sedReaderAddr.Value, t)) = R245_RES_OK then
    tbrTagMemTime_1.Position := t;
end;

{ ------------------------------------------------------------------------------
        1
------------------------------------------------------------------------------ }
procedure TfrmMain.btnSetTagMemTime_1Click(Sender: TObject);
begin
  ShowStatus(SetTagMemTime_1(sedReaderAddr.Value, tbrTagMemTime_1.Position));
end;

{ ------------------------------------------------------------------------------
      1
------------------------------------------------------------------------------ }
procedure TfrmMain.btnGetDumping_1Click(Sender: TObject);
var
  d: short;
begin
  if ShowStatus(GetDumping_1(sedReaderAddr.Value, d)) = R245_RES_OK then
    trbDumping_1.Position := -d;
end;

{ ------------------------------------------------------------------------------
      1
------------------------------------------------------------------------------ }
procedure TfrmMain.btnSetDumping_1Click(Sender: TObject);
begin
  ShowStatus(SetDumping_1(sedReaderAddr.Value, abs(trbDumping_1.Position)));
end;

{ ------------------------------------------------------------------------------
        1
------------------------------------------------------------------------------ }
procedure TfrmMain.btnGetNumTags_1Click(Sender: TObject);
var
  n: short;
begin
  edtNumTags_1.Text := '';
  if ShowStatus(GetNumTags_1(sedReaderAddr.Value, n)) = R245_RES_OK then
    edtNumTags_1.Text := IntToStr(n);
end;

{ ------------------------------------------------------------------------------
        1
------------------------------------------------------------------------------ }
procedure TfrmMain.btnGetFirstTag_1Click(Sender: TObject);
var
  ser: DWORD;
begin
  edtFirstTag_1.Text := '';
  if ShowStatus(GetFirstTag_1(sedReaderAddr.Value, ser)) = R245_RES_OK then
    edtFirstTag_1.Text := IntToHex((ser shr 24) and $00FF, 2) + ' ' +
      IntToHex((ser shr 16) and $00FF, 2) + ' ' +
      IntToHex((ser shr 8) and $00FF, 2) + ' ' +
      IntToHex(ser and $00FF, 2);
end;

{ ------------------------------------------------------------------------------
        1
------------------------------------------------------------------------------ }
procedure TfrmMain.btnGetNextTag_1Click(Sender: TObject);
var
  ser: DWORD;
begin
  edtNextTag_1.Text := '';
  if ShowStatus(GetNextTag_1(sedReaderAddr.Value, ser)) = R245_RES_OK then
    edtNextTag_1.Text := IntToHex((ser shr 24) and $00FF, 2) + ' ' +
      IntToHex((ser shr 16) and $00FF, 2) + ' ' +
      IntToHex((ser shr 8) and $00FF, 2) + ' ' +
      IntToHex(ser and $00FF, 2);
end;

//##############################################################################
//                            2
//##############################################################################
procedure TfrmMain.tbrTagMemTime_2Change(Sender: TObject);
begin
  lblTagMemTime_2.Caption := FloatToStr(tbrTagMemTime_2.Position / 10);
end;

{ ------------------------------------------------------------------------------
     2
------------------------------------------------------------------------------ }
procedure TfrmMain.rgrChanActive_2Click(Sender: TObject);
begin
  if rgrChanActive_2.ItemIndex = 0 then
    //   
    ShowStatus(SetChannelActivity_2(sedReaderAddr.Value, 0))
  else
    //   
    ShowStatus(SetChannelActivity_2(sedReaderAddr.Value, 1))
end;

{ ------------------------------------------------------------------------------
        2
------------------------------------------------------------------------------ }
procedure TfrmMain.btnGetTagMemTime_2Click(Sender: TObject);
var
  t: short;
begin
  if ShowStatus(GetTagMemTime_2(sedReaderAddr.Value, t)) = R245_RES_OK then
    tbrTagMemTime_2.Position := t;
end;

{ ------------------------------------------------------------------------------
        2
------------------------------------------------------------------------------ }
procedure TfrmMain.btnSetTagMemTime_2Click(Sender: TObject);
begin
  ShowStatus(SetTagMemTime_2(sedReaderAddr.Value, tbrTagMemTime_2.Position));
end;

{ ------------------------------------------------------------------------------
      2
------------------------------------------------------------------------------ }
procedure TfrmMain.btnGetDumping_2Click(Sender: TObject);
var
  d: short;
begin
  if ShowStatus(GetDumping_2(sedReaderAddr.Value, d)) = R245_RES_OK then
    trbDumping_2.Position := -d;
end;

{ ------------------------------------------------------------------------------
      2
------------------------------------------------------------------------------ }
procedure TfrmMain.btnSetDumping_2Click(Sender: TObject);
begin
  ShowStatus(SetDumping_2(sedReaderAddr.Value, abs(trbDumping_2.Position)));
end;

{ ------------------------------------------------------------------------------
        2
------------------------------------------------------------------------------ }
procedure TfrmMain.btnGetNumTags_2Click(Sender: TObject);
var
  n: short;
begin
  edtNumTags_2.Text := '';
  if ShowStatus(GetNumTags_2(sedReaderAddr.Value, n)) = R245_RES_OK then
    edtNumTags_2.Text := IntToStr(n);
end;

{ ------------------------------------------------------------------------------
        2
------------------------------------------------------------------------------ }
procedure TfrmMain.btnGetFirstTag_2Click(Sender: TObject);
var
  ser: DWORD;
begin
  edtFirstTag_2.Text := '';
  if ShowStatus(GetFirstTag_2(sedReaderAddr.Value, ser)) = R245_RES_OK then
    edtFirstTag_2.Text := IntToHex((ser shr 24) and $00FF, 2) + ' ' +
      IntToHex((ser shr 16) and $00FF, 2) + ' ' +
      IntToHex((ser shr 8) and $00FF, 2) + ' ' +
      IntToHex(ser and $00FF, 2);
end;

{ ------------------------------------------------------------------------------
        1
------------------------------------------------------------------------------ }
procedure TfrmMain.btnGetNextTag_2Click(Sender: TObject);
var
  ser: DWORD;
begin
  edtNextTag_2.Text := '';
  if ShowStatus(GetNextTag_2(sedReaderAddr.Value, ser)) = R245_RES_OK then
    edtNextTag_2.Text := IntToHex((ser shr 24) and $00FF, 2) + ' ' +
      IntToHex((ser shr 16) and $00FF, 2) + ' ' +
      IntToHex((ser shr 8) and $00FF, 2) + ' ' +
      IntToHex(ser and $00FF, 2);
end;

// #############################################################################
//              1.1.2. 
// #############################################################################
procedure TfrmMain.btnChangeAddrClick(Sender: TObject);
begin
  //    
  if (sedReaderAddr.Value <> sedSetNewAddress.Value) then begin
    if ShowStatus(SetNewReaderAddr(sedReaderAddr.Value, sedSetNewAddress.Value)) = R245_RES_OK then
      sedReaderAddr.Value := sedSetNewAddress.Value;
  end;
end;

{ ------------------------------------------------------------------------------
     
------------------------------------------------------------------------------ }
procedure TfrmMain.btnClearScreenClick(Sender: TObject);
begin
  lvwTransactions.Items.Clear;
end;

{ ------------------------------------------------------------------------------
     
------------------------------------------------------------------------------ }
procedure TfrmMain.btnClearBufferClick(Sender: TObject);
begin
  ShowStatus(ClearTransactions(sedReaderAddr.Value));
end;

{ ------------------------------------------------------------------------------
       
------------------------------------------------------------------------------ }
procedure TfrmMain.btnGetNumberClick(Sender: TObject);
var
  n: short;
begin
  if ShowStatus(GetNumTransactions(sedReaderAddr.Value, n)) = R245_RES_OK then
    edtNumTransact.Text := IntToStr(n)
  else
    edtNumTransact.Text := '';
end;

{ ------------------------------------------------------------------------------
       
------------------------------------------------------------------------------ }
procedure TfrmMain.btnGetNextClick(Sender: TObject);
var
  Ts: string;
  ListItem: TListItem;
  DT: TDateTime;
  //  
  Code, Chan: short;
  Tag: DWORD;
  Yr, Mt, Dy, Hr, Mn, Sc, DW: word;

  function CodeToStr(c: short): string;
  {
         ,   
           
  }
  begin
    case c of
      trnPowerOn:       result := 'Reader Power ON';
      trnPowerOff:      result := 'Reader Power off';
      trnNewTag:        result := 'Found NEW tag';
      trnLossTag:       result := 'Tag loss';
      trnShockOn:       result := 'Shock sensor ON';
      trnShockOff:      result := 'Shock sensor off';
      trnTamperOn:      result := 'Tamper ON';
      trnTamperOff:     result := 'Tamper off';
      trnBatteryOff:    result := 'Battery low';
      trnBatteryOn:     result := 'Battery normal';
    else
      result := 'Unknown transaction code';
    end; // case
  end;

begin
  //   
  if ShowStatus(GetNextTransaction(sedReaderAddr.Value, Code, Chan, Tag,
                                   Yr, Mt, Dy, Hr, Mn, Sc, DW)) = R245_RES_OK then
  begin
    // 
    ListItem := lvwTransactions.Items.Add;
    ListItem.Caption := IntToStr(TranNumber);
    ListItem.SubItems.Add('Ch = ' + IntToStr(Chan));
    //    :
    DT := EncodeDate(Yr, Mt, Dy);
    ListItem.SubItems.Add(FormatDateTime('dd/mm/yyyy', DT));
    DT := EncodeTime(Hr, Mn, Sc, 0);
    ListItem.SubItems.Add(FormatDateTime('hh:mm:ss', DT));
    Ts := IntToHex((Tag shr 24) and $00FF, 2) + ' ' +
          IntToHex((Tag shr 16) and $00FF, 2) + ' ' +
          IntToHex((Tag shr 8) and $00FF, 2) + ' ' +
          IntToHex(Tag and $00FF, 2);
    ListItem.SubItems.Add(Ts);
    ListItem.SubItems.Add(TransactionToString(Code));
    //
    Inc(TranNumber);
  end;
end;

end.

