unit Transact;

                                interface
////////////////////////////////////////////////////////////////////////////////
const
  trnPowerOn           = $01;
  trnPowerOff          = $02;
  trnNewTag            = $10;      //   -   
  trnLossTag           = $11;
  trnShockOn           = $20;      //  
  trnShockOff          = $21;      //  
  trnTamperOn          = $22;      //  
  trnTamperOff         = $23;      //  
  trnBatteryOff        = $24;      //  
  trnBatteryOn         = $25;      //  

  //   
  trnCarSensOn         = $101;     //  CAR 
  trnCarSensOff        = $102;     //  CAR 
  trnDcSensOn          = $103;     //  DC 
  trnDcSensOff         = $104;     //  DC 

  trnWrongInterface    = $110;     //   

  //     
  trnTagInOpposit      = $121;     //     
  trnChanLocked        = $122;     //  
  trnChanUnLocked      = $123;     //  
  trnCardSend          = $124;     //    
  trnWaitCarSens       = $125;     //    
  trnCarFound          = $126;     //    
  trnCarNotFound       = $127;     //      
  trnGateNotOpened     = $128;     // ... DC  ,  
  trnWaitGateClose     = $129;     //   
  trnAccessFinish      = $12A;     //  
  trnWaitAccess        = $12B;     //    
  trnWaitDefGate       = $12C;     //      
  trnGateClosed        = $12D;     //   
  trnGateNotClosed     = $12E;     //  ,   

  //  
  trnReaderConnectErr  = $150;     //    

function TransactionToString(c: integer): string;

                              implementation
////////////////////////////////////////////////////////////////////////////////

function TransactionToString(c: integer): string;
begin
  case c of
    trnPowerOn:         result := ' ';
    trnPowerOff:        result := ' ';
    trnNewTag:          result := ' ';
    trnLossTag:         result := ' ';
    trnShockOn:         result := ' ';
    trnShockOff:        result := '  ';
    trnTamperOn:        result := ' ';
    trnTamperOff:       result := '  ';
    trnBatteryOff:      result := ' ';
    trnBatteryOn:       result := '  ';

    //   
    trnCarSensOn:       result := '  ';
    trnCarSensOff:      result := '  ';
    trnDcSensOn:        result := '  ';
    trnDcSensOff:       result := '  ';

    trnWrongInterface:  result := ' ';

    //     
    trnTagInOpposit:    result := '   ';     //     
    trnChanLocked:      result := ' ';               //  
    trnChanUnLocked:    result := ' ';              //  
    trnCardSend:        result := '   ';         //    
    trnWaitCarSens:     result := '  ';      //    
    trnCarFound:        result := '  ';        //    
    trnCarNotFound:     result := '  ';          //      
    trnGateNotOpened:   result := '  ';              // ... DC  ,  
    trnWaitGateClose:   result := '  ';          //   
    trnAccessFinish:    result := '  ';            //  
    trnWaitAccess:      result := '  ';      //    
    trnWaitDefGate:     result := '    ';     //      
    trnGateClosed:      result := ' ';                 //   
    trnGateNotClosed:   result := '  ';              //  ,   

    //
    trnReaderConnectErr: result := '   ';

  else
    result       := ' ';
  end;end;

end.
